<template>
  <div class="container-xxl">
    <div class="row mt-5">
      <div class="col-12">
        <div
          id="publicacion_buscar_formulario"
          class="card card-flush shadow-sm"
        >
          <div class="card-body">
            <div class="d-flex flex-column flex-md-row justify-content-start">
              <div class="d-flex flex-column me-5 mt-5 mt-md-0">
                <input
                  id="publicacion_buscar_fecha_min"
                  v-model="mFormulario.fechaMin"
                  class="form-control"
                  type="text"
                  placeholder="Fecha mínima"
                >
              </div>

              <div class="d-flex flex-column me-5 mt-5 mt-md-0">
                <input
                  id="publicacion_buscar_fecha_max"
                  v-model="mFormulario.fechaMax"
                  class="form-control"
                  type="text"
                  placeholder="Fecha máxima"
                >
              </div>

              <div class="d-flex flex-column me-5 mt-5 mt-md-0">
                <button
                  id="publicacion_buscar_btn_buscar"
                  class="btn btn-primary"
                  @click="onPublicacionBuscar()"
                >
                  <i class="bi bi-arrow-clockwise fs-4 me-2" />Buscar
                </button>
              </div>

              <div class="d-flex flex-column mt-5 mt-md-0">
                <a
                  href="#publicacion_buscar_opcion_avanzada"
                  class="btn btn-link"
                  data-bs-toggle="collapse"
                >Opciones avanzadas
                </a>
              </div>
            </div>

            <div
              id="publicacion_buscar_opcion_avanzada"
              class="collapse"
            >
              <div class="separator separator-dashed mt-9 mb-6" />
              <div class="row g-8 mb-8">
                <div class="col-6 col-lg-3">
                  <label class="fs-6 form-label fw-bolder text-dark">Tipo de Ganado</label>
                  <select
                    v-model="mFormulario.tipoGanado"
                    class="form-select"
                    aria-label="Seleccione una opción"
                  >
                    <option
                      value="0"
                      selected
                    >
                      Todos
                    </option>
                    <option
                      v-for="tipoGanado in vFormulario.tiposGanados"
                      :key="tipoGanado.id"
                      :value="tipoGanado.id"
                    >
                      {{ tipoGanado.nombre }}
                    </option>
                  </select>
                </div>

                <div class="col-6 col-lg-3">
                  <label class="fs-6 form-label fw-bolder text-dark">Categoría de Ganado</label>
                  <select
                    v-model="mFormulario.categoriaGanado"
                    class="form-select"
                    aria-label="Seleccione una opción"
                  >
                    <option
                      value="0"
                      selected
                    >
                      Todos
                    </option>
                    <option
                      v-for="categoriaGanado in vFormulario.categoriasGanados"
                      :key="categoriaGanado.id"
                      :value="categoriaGanado.id"
                    >
                      {{ categoriaGanado.nombre }}
                    </option>
                  </select>
                </div>

                <div class="col-6 col-lg-3">
                  <label class="fs-6 form-label fw-bolder text-dark">Tipo de Raza</label>
                  <select
                    v-model="mFormulario.tipoRaza"
                    class="form-select"
                    aria-label="Seleccione una opción"
                  >
                    <option
                      value="0"
                      selected
                    >
                      Todos
                    </option>
                    <option
                      v-for="tipoRaza in vFormulario.tiposRazas"
                      :key="tipoRaza.id"
                      :value="tipoRaza.id"
                    >
                      {{ tipoRaza.nombre }}
                    </option>
                  </select>
                </div>

                <div class="col-6 col-lg-3">
                  <label class="fs-6 form-label fw-bolder text-dark">Tipo de Animal</label>
                  <select
                    v-model="mFormulario.tipoAnimal"
                    class="form-select"
                    aria-label="Seleccione una opción"
                  >
                    <option
                      value="0"
                      selected
                    >
                      Todos
                    </option>
                    <option
                      v-for="tipoAnimal in vFormulario.tiposAnimales"
                      :key="tipoAnimal.id"
                      :value="tipoAnimal.id"
                    >
                      {{ tipoAnimal.nombre }}
                    </option>
                  </select>
                </div>
              </div>

              <div class="row g-8">
                <div class="col-6 col-lg-3">
                  <label class="fs-6 form-label fw-bolder text-dark">Precio Min. (BOB)</label>
                  <input-marcador
                    ref="publicacionBuscarInputPrecioMin"
                    identificador="publicacion_buscar_input_precio_min"
                    :valor-min="0"
                    :valor-max="500000"
                    :valor-escala="1000"
                    :valor-inicial="0"
                    titulo="Precio mínimo"
                  />
                </div>
                <div class="col-6 col-lg-3">
                  <label class="fs-6 form-label fw-bolder text-dark">Precio Max. (BOB)</label>
                  <input-marcador
                    ref="publicacionBuscarInputPrecioMax"
                    identificador="publicacion_buscar_input_precio_max"
                    :valor-min="0"
                    :valor-max="500000"
                    :valor-escala="1000"
                    :valor-inicial="0"
                    titulo="Precio máximo"
                  />
                </div>
                <div class="col-6 col-lg-3">
                  <label class="fs-6 form-label fw-bolder text-dark">Peso Min. (Kg)</label>
                  <input-marcador
                    ref="publicacionBuscarInputPesoMin"
                    identificador="publicacion_buscar_input_peso_min"
                    :valor-min="0"
                    :valor-max="2500"
                    :valor-escala="100"
                    :valor-inicial="0"
                    titulo="Peso mínimo"
                  />
                </div>
                <div class="col-6 col-lg-3">
                  <label class="fs-6 form-label fw-bolder text-dark">Peso Max. (Kg)</label>
                  <input-marcador
                    ref="publicacionBuscarInputPesoMax"
                    identificador="publicacion_buscar_input_peso_max"
                    :valor-min="0"
                    :valor-max="2500"
                    :valor-escala="100"
                    :valor-inicial="0"
                    titulo="Peso máximo"
                  />
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <div class="row mt-5">
      <div class="col-12">
        <div class="row">
          <tabla-buscar
            :ventas="ventas"
            :response-listar="response.listar"
          />
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import TablaBuscar from "@/components/panel/venta/TablaVentaBuscar";
import InputMarcador from "@/components/util/InputMarcador";

import flatpickr from "flatpickr";
import moment from "moment";
import {Spanish} from "flatpickr/dist/l10n/es";
import Servicio from "@/core/servicio/Servicio";
import Ruta from "@/core/servicio/Ruta";
import Toast from "@/core/util/Toast";
import BloqueoUI from "@/core/util/BloqueoUI";

export default {
  name: 'VentaBuscar',
  components: {
    TablaBuscar, InputMarcador
  },
  data() {
    return {
      mFormulario: {
        fechaMin: '',
        fechaMax: '',
        precioMin: 0,
        precioMax: 0,
        pesoMin: 0,
        pesoMax: 0,
        tipoGanado: 0,
        categoriaGanado: 0,
        tipoRaza: 0,
        tipoAnimal: 0
      },
      vFormulario: {
        tiposGanados: [],
        categoriasGanados: [],
        tiposRazas: [],
        tiposAnimales: []
      },
      componentes: {
        bloqueoUI: null
      },
      response: {
        listar: 'LOADING'
      },
      ventas: [],
    }
  },

  mounted() {
    flatpickr("#publicacion_buscar_fecha_min", { "locale": Spanish });
    flatpickr("#publicacion_buscar_fecha_max", { "locale": Spanish });

    this.mFormulario.fechaMax = moment().format('yyyy-MM-D');
    this.mFormulario.fechaMin = moment().subtract(1, 'M').format('yyyy-MM-D');
    this.componentes.bloqueoUI = new BloqueoUI('#publicacion_buscar_formulario', '#publicacion_buscar_btn_buscar');
    this.onPublicacionFormularioBuscar();
    this.onPublicacionBuscar();
  },

  methods: {
    onPublicacionFormularioBuscar() {
      Servicio.get(Ruta.PANEL_PUBLICACION_FORMULARIO_BUSCAR).then( (data) => {
        this.vFormulario = data.data;
      }).catch( (error) => {
        Toast.mostrarError(error);
      });
    },

    onPublicacionBuscar() {
      this.ventas = [];
      this.mFormulario.precioMin = this.$refs.publicacionBuscarInputPrecioMin.value;
      this.mFormulario.precioMax = this.$refs.publicacionBuscarInputPrecioMax.value;
      this.mFormulario.pesoMin = this.$refs.publicacionBuscarInputPesoMin.value;
      this.mFormulario.pesoMax = this.$refs.publicacionBuscarInputPesoMax.value;

      this.response.listar = 'LOADING';
      this.componentes.bloqueoUI.iniciarBloqueoFormulario();

      Servicio.post(Ruta.PANEL_PUBLICACION_BUSCAR, this.mFormulario).then( (data) => {
        this.response.listar = data.estado;
        this.ventas = data.data;
        this.componentes.bloqueoUI.terminarBloqueoFormulario();
      }).catch( (error) => {
        this.response.listar = 'ERROR';
        this.componentes.bloqueoUI.terminarBloqueoFormulario();
        Toast.mostrarError(error);
      });
    },
  },

}
</script>